'+----------------------------------------+
'| Gilbreath01                            |
'|   Demonstrate Gilbreath principle in   |
'|   action for draws of four in a group  |
'+----------------------------------------+
'+----------------------------+
'| DrawOut$:                  |
'| ========                   |
'| the order of tubes from    |
'| which each counter is      |
'| drawn: example ABAA        |
'+----------------------------+
dim DrawOut$(16, 4)
'+----------------------------+
'| Results$:                  |
'| ========                   |
'| the results of all the     |
'| possible draws:            |
'|   example  BYGR            |
'+----------------------------+
dim Results$(16, 4)

'+----------------------------+
'| Fill TubeA$ and TubeB$     |
'+----------------------------+
for i = 1 to 16
  TubeA$ = TubeA$ + "BRGY"
  TubeB$ = TubeB$ + "YGRB"
'+----------------------------+
'| Default: TubeA$ for draws  |
'+----------------------------+
  for j = 1 to 4
    DrawOut$(i, j) = "A"
  next
next

'+----------------------------+
'| Create all perms of draws  |
'| from TubeA$ and TubeB$     |
'+----------------------------+
for i = 1 to 16
  j = i - 1
  if (j and 1) then DrawOut$(i, 1) = "B"
  if (j and 2) then DrawOut$(i, 2) = "B"
  if (j and 4) then DrawOut$(i, 3) = "B"
  if (j and 8) then DrawOut$(i, 4) = "B"
next

'+----------------------------+
'| Perform draws from tubes   |
'+----------------------------+
for i = 1 to 16
  for j = 1 to 4
    if DrawOut$(i, j) = "A" then
      Results$(i, j) = left$(TubeA$, 1)
      TubeA$ = mid$(TubeA$, 2)
    else
      Results$(i, j) = left$(TubeB$, 1)
      TubeB$ = mid$(TubeB$, 2)
    end if
  next
next

'+----------------------------+
'| Analyse and print results  |
'+----------------------------+
print "Gilbreath01: illustrated for groups of four"
print

for i = 1 to 16
  Colours = 0
  for j = 1 to 4
    x$ = Results$(i, j)
    select case x$
    case "B"
      Colours = Colours + 1
    case "R"
      Colours = Colours + 2
    case "G"
      Colours = Colours + 4
    case "Y"
      Colours = Colours + 8
    end select
    print x$;" ";
  next
'+----------------------------+
'| 1+2+4+8 --> all colours    |
'|             drawn          |
'+----------------------------+
  if Colours = 15 then
    print "   success |";
  end if
  print
next
stop
