'+----------------------------------------+
'| Gilbreath02                            |
'|   Demonstrate Gilbreath principle in   |
'|   action with two full decks           |
'+----------------------------------------+
'+----------------------------+
'| DeckA$:                    |
'| ======                     |
'| the first deck, shuffled   |
'+----------------------------+
dim DeckA$(52)
for i = 1 to 4
  suit$ = mid$("SHDC", i, 1)
  j = i * 13 - 13
  for k = 1 to 13
    rank$ = mid$("23456789TJQKA", k, 1)
    DeckA$(j + k) = rank$ + suit$
  next
next
for i = 52 to 2 step -1
  j = int(rnd(0) * i + 1)
  x$ = DeckA$(i): DeckA$(i) = DeckA$(j):DeckA$(j) = x$
next
'+----------------------------+
'| DeckB$:                    |
'| ======                     |
'| the second deck, reverse   |
'| order of first deck        |
'+----------------------------+
dim DeckB$(52)
for i = 1 to 52
  DeckB$(53 - i) = DeckA$(i)
next
'+----------------------------+
'| Choice:                    |
'| ========                   |
'| 52 as 0, 52 as 1, shuffled |
'+----------------------------+
dim Choice(104)
for i = 1 to 52
  Choice(i) = 1
next
for i = 104 to 2 step -1
  j = int(rnd(0) * i + 1)
  k = Choice(i) : Choice(i) = Choice(j) : Choice(j) = k
next
'+----------------------------------------+
'| First pass:                            |
'|   Riffle shuffle Decks A and B         |
'|   together to form DblDeck C           |
'+----------------------------------------+
Print "Riffle shuffle, then take first 52 cards"
dim DblDeckC$(104)
ja = 0 : jb = 0
for i = 1 to 104
  select case Choice(i)
  case 0
    ja = ja + 1
    DblDeckC$(i) = DeckA$(ja)
  case else
    jb = jb + 1
    DblDeckC$(i) = DeckB$(jb)
  end select
next
'+----------------------------+
'| Keep the first 52 cards    |
'| of DblDeck C as Deck D     |
'+----------------------------+
dim DeckD$(52)
dim AccountD(4, 13)
for i = 1 to 52
  x$ = DblDeckC$(i)
  DeckD$(i) = x$
  rank$ = left$(x$,1)
  suit$ = right$(x$,1)
  j = instr("SHDC", suit$)
  k = instr("23456789TJQKA", rank$)
  AccountD(j, k) = AccountD(j, k) + 1
next
'+----------------------------+
'| Analyse whether success    |
'| or failure                 |
'+----------------------------+
Msg$ = " Success !"
for i = 1 to 4
  for j = 1 to 13
    if AccountD(i, j) <> 1 then
      Msg$ = " Failure"
    end if
  next
next
print : print Msg$ : print
'+----------------------------------------+
'| Second pass:                           |
'|   Select from Decks A and B alternately|
'|   to form Deck E, based on throws of   |
'|   a single die                         |
'+----------------------------------------+
Print "Compose deck from two decks via die throws"
dim DeckE$(52)
dim AccountE(4, 13)
ja = 0 : jb = 0 : je = 0 : alternator = 0
'+----------------------------+
'| single throw of a die      |
'+----------------------------+
do
  i = int(rnd(0) * 6 + 1)
  alternator = 1 - alternator
  select case alternator
'+----------------------------+
'| single throw of a die      |
'+----------------------------+
  case 0
    do
      jc = jc + 1 : ja = ja + 1
      DeckE$(jc) = DeckA$(ja)
      if jc = 52 then exit do
      i = i - 1
    loop until i = 0
  case else
    do
      jc = jc + 1 : jb = jb + 1
      DeckE$(jc) = DeckB$(jb)
      if jc = 52 then exit do
      i = i = 1
    loop until i = 0
  end select
loop until jc = 52
'+----------------------------+
'| Analyse whether success    |
'| or failure                 |
'+----------------------------+
Msg$ = " Success !"
for i = 1 to 52
  x$ = DeckE$(i)
  rank$ = left$(x$,1)
  suit$ = right$(x$,1)
  j = instr("SHDC", suit$)
  k = instr("23456789TJQKA", rank$)
  AccountE(j, k) = AccountE(j, k) + 1
  if AccountE(j, k) > 1 then
    Msg$ = " Failure"
  end if
next
print : print Msg$


stop
