'+----------------------------------------+
'| Gilbreath03                            |
'|   Demonstrate Gilbreath principle in   |
'|   action with a three-suit deck        |
'+----------------------------------------+
'+----------------------------+
'| ShDeckA$:                  |
'| ======                     |
'| the first deck, shuffled   |
'| (clubs suit removed)       |
'+----------------------------+
dim ShDeckA$(39)
for i = 1 to 13
  rank$ = mid$("23456789TJQKA", i, 1)
  j = i * 3 - 3
  for k = 1 to 3
    suit$ = mid$("SHD", k, 1)
    ShDeckA$(j + k) = rank$ + suit$
  next
next
'+----------------------------+
'| Piles B & C:               |
'| ===========                |
'| formed by cutting in the   |
'| midst of short deck A      |
'+----------------------------+
dim PileB$(22)
dim PileC$(22)
for Trial = 1 to 3
  print : print "Trial ";Trial;":"
  inPileB = 17 + Trial
  inPileC = 22 - Trial
  PileB$(0) = str$(inPileB)
  PileC$(0) = str$(inPileC)
  ja = 0 : jb = 0 : jc = 0
  do
    ja = ja + 1
    jb = jb + 1
    PileB$(jb) = ShDeckA$(ja)
  loop until jb = inPileB
  suit = instr("SHDC", right$(PileB$(jb), 1))
  print "  card above the cut is a ";
  print word$("Spade Heart Diamond Club", suit)
  do
    ja = ja + 1
    jc = jc + 1
    PileC$(jc) = ShDeckA$(ja)
  loop until jc = inPileC
'+----------------------------+
'| Choice(39):                |
'| ==========                 |
'| 0 = select from Pile B     |
'| 1 = select from Pile C     |
'+----------------------------+
dim Choice(39)
  for i = 1 to 39
    if i > inPileB then
      Choice(i) = 1
    else
      Choice(i) = 0
    end if
  next
  for i = 39 to 2 step -1
    j = int(rnd(0) * i + 1)
    k = Choice(i)
    Choice(i) = Choice(j)
    Choice(j) = k
  next
'+----------------------------+
'| ShDeckD$:                  |
'| ======                     |
'| the second deck, short,    |
'| from riffle shuffle        |
'+----------------------------+
dim ShDeckD$(39)
  jb = 0 : jc = 0
  for i = 1 to 39
    select case Choice(i)
    case 0
      jb = jb + 1
      ShDeckD$(i) = PileB$(jb)
    case else
      jc = jc + 1
      ShDeckD$(i) = PileC$(jc)
    end select
  next

  for i = 1 to 13
    j = 0
    for k = 1 to 3
      x$ = right$(ShDeckD$(i * 3 + k - 3), 1)
      j = j + instr("SxHD", x$)
    next
    x$ = mid$("SSHxDHD", j - 4, 1)
    select case x$
    case "S"
      x$ = "Spades"
    case "H"
      x$ = "Hearts"
    case "D"
      x$ = "Diamonds"
    case else
      x$ = ""
    end select
    if len(x$) > 0 then
      print "  triplet ";i;" has a pair of ";x$
    end if
  next
next

stop
